.section .data

fmt:
	.string "Rückgabe: %d\n\0"

.section .text
.global main

main:
	pushl %ebp                     /* Frame Pointer aufbauen */
	movl %esp, %ebp

	subl $16, %esp                 /* Platz auf dem Stack schaffen */

	/* ---------------- Aufruf der eigenen Funktion ----------------- */

	                               /*  :           :                  */
	                               /*  :           :                  */
	                               /*  +-----------+                  */
	                               /*  | Rücksp.   |                  */
	                               /*  | EBP alt 1 |  <--     (%ebp)  */
	                               /*  +-----------+                  */
	movl $4,  -4(%ebp)             /*  |  4        |  <--   -4(%ebp)  */
	movl $3,  -8(%ebp)             /*  |  3        |  <--   -8(%ebp)  */
	movl $2, -12(%ebp)             /*  |  2        |  <--  -12(%ebp)  */
	movl $1, -16(%ebp)             /*  |  1        |  <--  -16(%ebp)  */
	call foo                       /* =#===========#================= */
	                               /*  :           :                  */
	                               /*  :           :                  */

	                               /* Rückgabewert --> %eax */

	/* ----------------- Ausgabe des Rückgabewerts ------------------ */

	                               /*  :           :                  */
	                               /*  :           :                  */
	                               /*  +-----------+                  */
	                               /*  | Rücksp.   |                  */
	                               /*  | EBP alt 1 |  <--     (%ebp)  */
	                               /*  +-----------+                  */
	                               /*  |  4        |  <--   -4(%ebp)  */
	                               /*  |  3        |  <--   -8(%ebp)  */
	movl %eax, -12(%ebp)           /*  |  -2       |  <--  -12(%ebp)  */
	movl $fmt, -16(%ebp)           /*  |  $fmt     |  <--  -16(%ebp)  */
	call printf                    /* =#===========#================= */
	                               /*  :           :                  */
	                               /*  :           :                  */

	/* ------------------ Ende des Hauptprogramms ------------------- */

	movl $0, %eax                  /* return 0 */
	leave                          /* Framepointer abbauen */
	ret                            /* Rücksprung aus main() */

foo:
	pushl %ebp
	movl %esp, %ebp

	/* Berechne hier:

		a = 1 - 2;
		b = 3 - 4;
		return a + b;

	*/

	subl $8, %esp

	                               /*  :           :                  */
	                               /*  :           :                  */
	                               /*  +-----------+                  */
	                               /*  | Rücksp.   |                  */
	/* a = 1 - 2 */                /*  | EBP alt 1 |                  */
	movl  8(%ebp), %ecx            /*  +-----------+                  */
	subl 12(%ebp), %ecx            /*  |  4        |  <-- 20(%ebp)    */
	movl %ecx, -4(%ebp)            /*  |  3        |  <-- 16(%ebp)    */
	                               /*  |  2        |  <-- 12(%ebp)    */
	/* b = 3 - 4 */                /*  |  1        |  <--  8(%ebp)    */
	movl 16(%ebp), %ecx            /*  +-----------+----------------- */
	subl 20(%ebp), %ecx            /*  | Rücksp.   |                  */
	movl %ecx, -8(%ebp)            /*  | EBP alt 2 |  <--   (%ebp)    */
	                               /*  +-----------+                  */
	/* a + b */                    /*  |  a        |  <-- -4(%ebp)    */
	movl -4(%ebp), %ecx            /*  |  b        |  <-- -8(%ebp)    */
	addl -8(%ebp), %ecx            /* =#===========#================= */
	                               /*  :           :                  */
	                               /*  :           :                  */

	movl %ecx, %eax                /* Rückgabewert --> %eax */

	leave
	ret
